Subject: Re: bug#68690: Segmentation fault building with native-comp

From: Stefan Monnier <[email-masked]>
Date: Thu, 25 Jan 2024 17:39:23 -0500

> Sorry, my fault -- indeed maphash 'supports' irregular mutation in the sense
> that it shouldn't crash or corrupt Emacs if the rules are violated. I can't
> reproduce the reported crash(es) on my platform but is my understanding
> correct that no other uses of DOHASH caused any trouble?

AFAIK the current DOHASH code in `master` works fine (tho a bit ugly).
The remaining build failure that Eli is seeing seems unrelated.

> This patch reverts my last change to Fmaphash and yours to DOHASH. It's
> perfectly fine to forego DOHASH in Fmaphash, it's chums with the hash-table
> implementation. Assuming that the problems were confined to Fmaphash, this
> should be safe to apply.

The build failure didn't come via maphash` but via the DOHASH in
`comp.c` that calls `compile_function` (which apparently can cause the
hash table to be resized).
So `maphash` is clearly not the only "offender".

        Stefan